## kristall 0.3+git20210303.763bd81+dfsg

=== Makefile ===
# Install to /usr/local unless otherwise specified, such as `make PREFIX=/app`
PREFIX?=/usr/local

# Man pages by default instaled to /usr/local/share/man, like above this can
# be specified on command line.
MANPATH?=$(PREFIX)/share/man

# What to run to install various files
INSTALL?=install
# Run to install the actual binary
INSTALL_PROGRAM=$(INSTALL) -Dm 755
# Run to install application data, with differing permissions
INSTALL_DATA=$(INSTALL) -m 644

# Directories into which to install the various files
bindir=$(DESTDIR)$(PREFIX)/bin
sharedir=$(DESTDIR)$(PREFIX)/share
mandir=$(DESTDIR)$(MANPATH)/man1
MAKEDIR=mkdir -p

# Default Qmake Command For Ubuntu (and probably other Debian) distributions

QMAKE_COMMAND := qmake
# For Fedora 32 and similar distributions, use the next line instead of the above.
# QMAKE_COMMAND := /usr/bin/qmake-qt5

UNAME := $(shell uname)
# Homebrew on macOS does not link Qt5 into the system path.
ifeq ($(UNAME),Darwin)
	HOMEBREW_PATH=export PATH="$(PATH):/usr/local/opt/qt/bin";
endif

kristall: build/kristall
	cp build/kristall $@

.PHONY: build/kristall
build/kristall: src/*
	mkdir -p build
	cd build; $(HOMEBREW_PATH) $(QMAKE_COMMAND) CONFIG+=$(QMAKE_CONFIG) ../src/kristall.pro && $(MAKE)
	cd doc; ./gen-man.sh

install: kristall
	# Prepare directories
	$(MAKEDIR) $(sharedir)/icons/hicolor/scalable/apps/
	$(MAKEDIR) $(sharedir)/icons/hicolor/16x16/apps/
	$(MAKEDIR) $(sharedir)/icons/hicolor/32x32/apps/
	$(MAKEDIR) $(sharedir)/icons/hicolor/64x64/apps/
	$(MAKEDIR) $(sharedir)/icons/hicolor/128x128/apps/
	$(MAKEDIR) $(sharedir)/applications/
	$(MAKEDIR) $(sharedir)/mime/packages/
	$(MAKEDIR) $(mandir)
	$(MAKEDIR) $(bindir)

	# Install files
	$(INSTALL_DATA) src/icons/kristall.svg $(sharedir)/icons/hicolor/scalable/apps/net.random-projects.kristall.svg
	$(INSTALL_DATA) src/icons/kristall-16.png $(sharedir)/icons/hicolor/16x16/apps/net.random-projects.kristall.png
	$(INSTALL_DATA) src/icons/kristall-32.png $(sharedir)/icons/hicolor/32x32/apps/net.random-projects.kristall.png
	$(INSTALL_DATA) src/icons/kristall-64.png $(sharedir)/icons/hicolor/64x64/apps/net.random-projects.kristall.png
	$(INSTALL_DATA) src/icons/kristall-128.png $(sharedir)/icons/hicolor/128x128/apps/net.random-projects.kristall.png
	$(INSTALL_DATA) Kristall.desktop $(sharedir)/applications/Kristall.desktop
	$(INSTALL_DATA) kristall-mime-info.xml $(sharedir)/mime/packages/kristall.xml
	$(INSTALL_DATA) doc/kristall.1 $(mandir)/kristall.1
	$(INSTALL_PROGRAM) kristall $(bindir)/kristall

uninstall:
	# Remove the .desktop
	rm -f $(sharedir)/applications/Kristall.desktop
	# Remove the icons
	rm -f $(sharedir)/icons/hicolor/scalable/apps/net.random-projects.kristall.png
	rm -f $(sharedir)/icons/hicolor/*x*/apps/net.random-projects.kristall.png
	# Remove the binary
	rm -f $(bindir)/kristall
	# Remove man page
	rm -f $(mandir)/kristall.1

clean:
	rm -rf build
	rm -f kristall

=== lib/cmark/src/CMakeLists.txt ===
if(${CMAKE_VERSION} VERSION_GREATER "3.3")
    cmake_policy(SET CMP0063 NEW)
endif()

set(LIBRARY "libcmark")
set(STATICLIBRARY "libcmark_static")
set(HEADERS
  cmark.h
  parser.h
  buffer.h
  node.h
  iterator.h
  chunk.h
  references.h
  utf8.h
  scanners.h
  inlines.h
  houdini.h
  cmark_ctype.h
  render.h
  )
set(LIBRARY_SOURCES
  cmark.c
  node.c
  iterator.c
  blocks.c
  inlines.c
  scanners.c
  scanners.re
  utf8.c
  buffer.c
  references.c
  render.c
  man.c
  xml.c
  html.c
  commonmark.c
  latex.c
  houdini_href_e.c
  houdini_html_e.c
  houdini_html_u.c
  cmark_ctype.c
  ${HEADERS}
  )

set(PROGRAM "cmark")
set(PROGRAM_SOURCES main.c)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmark_version.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmark_version.h)

include (GenerateExportHeader)

add_executable(${PROGRAM} ${PROGRAM_SOURCES})

if (CMARK_STATIC)
  target_link_libraries(${PROGRAM} ${STATICLIBRARY})
  # Disable the PUBLIC declarations when compiling the executable:
  set_target_properties(${PROGRAM} PROPERTIES
    COMPILE_FLAGS -DCMARK_STATIC_DEFINE)
elseif (CMARK_SHARED)
  target_link_libraries(${PROGRAM} ${LIBRARY})
endif()

# -fvisibility=hidden
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

if (CMARK_SHARED)
  add_library(${LIBRARY} SHARED ${LIBRARY_SOURCES})
  set_target_properties(${LIBRARY} PROPERTIES
    MACOSX_RPATH TRUE
    OUTPUT_NAME "cmark"
    # Avoid name clash between PROGRAM and LIBRARY pdb files.
    PDB_NAME cmark_dll
    # Include minor version and patch level in soname for now.
    SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
    VERSION ${PROJECT_VERSION})
  target_include_directories(${LIBRARY} INTERFACE
    $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)

  generate_export_header(${LIBRARY}
    BASE_NAME ${PROJECT_NAME})

  list(APPEND CMARK_INSTALL ${LIBRARY})
endif()

if (CMARK_STATIC)
  add_library(${STATICLIBRARY} STATIC ${LIBRARY_SOURCES})
  set_target_properties(${STATICLIBRARY} PROPERTIES
    COMPILE_FLAGS -DCMARK_STATIC_DEFINE
    OUTPUT_NAME "cmark$<$<BOOL:${MSVC}>:_static>"
    POSITION_INDEPENDENT_CODE ON
    VERSION ${PROJECT_VERSION})
  target_include_directories(${STATICLIBRARY} INTERFACE
    $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)

  if (NOT CMARK_SHARED)
    generate_export_header(${STATICLIBRARY}
      BASE_NAME ${PROJECT_NAME})
  endif()

  list(APPEND CMARK_INSTALL ${STATICLIBRARY})
endif()

if (MSVC)
  set_property(TARGET ${PROGRAM}
    APPEND PROPERTY LINK_FLAGS /INCREMENTAL:NO)
endif(MSVC)

if(NOT MSVC OR CMAKE_HOST_SYSTEM_NAME STREQUAL Windows)
  set(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
  include(InstallRequiredSystemLibraries)
endif()

set(libdir lib${LIB_SUFFIX})

install(TARGETS ${PROGRAM} ${CMARK_INSTALL}
  EXPORT cmark
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${libdir}
  ARCHIVE DESTINATION ${libdir}
  )

if(CMARK_SHARED OR CMARK_STATIC)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libcmark.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libcmark.pc @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libcmark.pc
    DESTINATION ${libdir}/pkgconfig)

  install(FILES
    cmark.h
    ${CMAKE_CURRENT_BINARY_DIR}/cmark_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/cmark_version.h
    DESTINATION include
    )

  install(EXPORT cmark DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake)

  set(CMARK_TARGETS_FILE ${CMAKE_CURRENT_BINARY_DIR}/cmarkTargets.cmake)
  configure_file(cmarkConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmarkConfig.cmake)
  export(TARGETS ${CMARK_INSTALL} FILE ${CMARK_TARGETS_FILE})
endif()

# Feature tests
include(CheckIncludeFile)
include(CheckCSourceCompiles)
CHECK_INCLUDE_FILE(stdbool.h HAVE_STDBOOL_H)
CHECK_C_SOURCE_COMPILES(
  "int main() { __builtin_expect(0,0); return 0; }"
  HAVE___BUILTIN_EXPECT)
CHECK_C_SOURCE_COMPILES("
  int f(void) __attribute__ (());
  int main() { return 0; }
" HAVE___ATTRIBUTE__)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h)

if(CMARK_LIB_FUZZER)
  add_executable(cmark-fuzz ../test/cmark-fuzz.c ${LIBRARY_SOURCES})
  target_link_libraries(cmark-fuzz "${CMAKE_LIB_FUZZER_PATH}")

  # cmark is written in C but the libFuzzer runtime is written in C++ which
  # needs to link against the C++ runtime.
  set_target_properties(cmark-fuzz PROPERTIES
    LINKER_LANGUAGE CXX)
endif()

=== debian/changelog ===
kristall (0.3+git20210303.763bd81+dfsg-1) experimental; urgency=medium

  * Initial release. (Closes: #984530)

 -- Carlos Henrique Lima Melara <charlesmelara@outlook.com>  Tue, 21 Sep 2021 23:09:30 -0300

=== debian/control ===
Source: kristall
Section: web
Priority: optional
Maintainer: Carlos Henrique Lima Melara <charlesmelara@outlook.com>
Build-Depends: debhelper-compat (= 13),
               libcmark-dev,
               libqt5svg5-dev,
               libssl-dev,
               qt5-qmake,
               qtmultimedia5-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://kristall.random-projects.net/
Vcs-Git: https://salsa.debian.org/debian/kristall.git
Vcs-Browser: https://salsa.debian.org/debian/kristall

Package: kristall
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: high-quality visual cross-platform gemini browser
 Kristall is a browser without support for css/js/wasm or graphical
 websites. It can display user-styled documents in several formats,
 including gemini, html, markdown and others provided by a server
 via gemini, gopher, http, finger, etc.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PREFIX=/usr
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?V?(\d[\d.]*)\.tar\.gz%kristall-$1.tar.gz%, \
   dversionmangle=s/@DEB_EXT@//" \
https://github.com/MasterQ32/kristall/releases \
   (?:.*?/)?V?@ANY_VERSION@@ARCHIVE_EXT@

## kristall 0.4%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: kristall
 Section: web
 Priority: optional
-Maintainer: Carlos Henrique Lima Melara <charlesmelara@outlook.com>
+Maintainer: Carlos Henrique Lima Melara <charlesmelara@riseup.net>
 Build-Depends: debhelper-compat (= 13),
                libcmark-dev,
+               libgumbo-dev,
                libqt5svg5-dev,
                libssl-dev,
                qt5-qmake,
-               qtmultimedia5-dev
-Standards-Version: 4.6.0
+               qtmultimedia5-dev,
+               qttools5-dev-tools
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://kristall.random-projects.net/
 Vcs-Git: https://salsa.debian.org/debian/kristall.git

## kristall 0.4+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
-# Install to /usr/local unless otherwise specified, such as `make PREFIX=/app`
+# Install to ~/.local unless otherwise specified, such as `make PREFIX=/app`
 PREFIX?=/usr/local
 
 # Man pages by default instaled to /usr/local/share/man, like above this can
 # be specified on command line.
-MANPATH?=$(PREFIX)/share/man
+MANPATH2?=$(PREFIX)/share/man
 
 # What to run to install various files
 INSTALL?=install
@@ -15,7 +15,7 @@
 # Directories into which to install the various files
 bindir=$(DESTDIR)$(PREFIX)/bin
 sharedir=$(DESTDIR)$(PREFIX)/share
-mandir=$(DESTDIR)$(MANPATH)/man1
+mandir=$(DESTDIR)$(MANPATH2)/man1
 MAKEDIR=mkdir -p
 
 # Default Qmake Command For Ubuntu (and probably other Debian) distributions
@@ -25,9 +25,14 @@
 # QMAKE_COMMAND := /usr/bin/qmake-qt5
 
 UNAME := $(shell uname)
+UNAME_M := $(shell uname -m)
 # Homebrew on macOS does not link Qt5 into the system path.
 ifeq ($(UNAME),Darwin)
-	HOMEBREW_PATH=export PATH="$(PATH):/usr/local/opt/qt/bin";
+	ifeq ($(UNAME_M),arm64)
+		HOMEBREW_PATH=export PATH="$(PATH):/opt/homebrew/opt/qt5/bin";
+	else
+		HOMEBREW_PATH=export PATH="$(PATH):/usr/local/opt/qt/bin";
+	endif
 endif
 
 kristall: build/kristall
@@ -36,7 +41,7 @@
 .PHONY: build/kristall
 build/kristall: src/*
 	mkdir -p build
-	cd build; $(HOMEBREW_PATH) $(QMAKE_COMMAND) CONFIG+=$(QMAKE_CONFIG) ../src/kristall.pro && $(MAKE)
+	cd build; $(HOMEBREW_PATH) $(QMAKE_COMMAND) "CONFIG+=$(QMAKE_CONFIG)" ../src/kristall.pro && $(MAKE)
 	cd doc; ./gen-man.sh
 
 install: kristall
@@ -65,6 +70,8 @@
 uninstall:
 	# Remove the .desktop
 	rm -f $(sharedir)/applications/Kristall.desktop
+	# Remove the mime entry
+	rm -f $(sharedir)/mime/packages/kristall.xml
 	# Remove the icons
 	rm -f $(sharedir)/icons/hicolor/scalable/apps/net.random-projects.kristall.png
 	rm -f $(sharedir)/icons/hicolor/*x*/apps/net.random-projects.kristall.png
@@ -75,4 +82,5 @@
 
 clean:
 	rm -rf build
+	rm -f doc/kristall.1
 	rm -f kristall

=== debian/changelog ===
kristall (0.4+dfsg-5) experimental; urgency=medium

  * Team upload.
  * d/control: bump standards-version to 4.7.2

 -- Bianca Costa Galvão <biancagalvao@usp.br>  Wed, 11 Jun 2025 19:05:47 +0000

kristall (0.4+dfsg-4) unstable; urgency=medium

  * debian/rules: really make kristall cross-buildable.
    Thanks to Helmut Grohne for the patch. (Closes: #1070049)

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Sat, 04 May 2024 13:07:36 -0300

kristall (0.4+dfsg-3) unstable; urgency=medium

  * debian/control: bump Standards-Version to 4.7.0, no changes needed.
  * debian/copyright: update packaging copyright years.
  * debian/rules: use the host architecture qmake. Thanks to Helmut Grohne.
    (Closes: #1070049)

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Mon, 29 Apr 2024 15:56:39 -0300

kristall (0.4+dfsg-2) unstable; urgency=medium

  * debian/control: update maintainer's email.
  * debian/copyright: update packaging copyright info.
  * debian/patches: refresh patch headers and drop patch numbers in filename.
      - gen-man-use-printf-instead-of-echo.patch: cherry-pick from upstream.
  * debian/watch: update to use github api.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Sun, 11 Jun 2023 23:10:13 -0300

kristall (0.4+dfsg-1) unstable; urgency=medium

  * New upstream version 0.4+dfsg.
  * debian/README.Debian: qtwayland5 is installed by default, so we
    can delete this readme.
  * debian/control:
      - Add new packages to Build-Depends.
      - Bump Standards-Version to 4.6.2 - no changes needed.
  * debian/copyright: exclude already packaged libs and their copyright
    information.
  * debian/lintian-overrides: remove unused override.
  * debian/patches/:
      - 010-Add_debian_font_path.patch: refresh patch.
      - {020,030,040,050}*: remove. Merged upstream.
      - 020-fix_typo_in_help_page.patch: fix typo in upstream code (new).
      - 030-Fix_kristall_version.patch: fix missing kristall version (new).
  * debian/rules: export KRISTALL_VERSION and QMAKE_CONFIG to link dynamically
    to cmark and gumbo libs.
  * debian/watch: add repacksuffix so uscan can name the orig tarball
    correctly and update filenamemangle.

 -- Carlos Henrique Lima Melara <charlesmelara@outlook.com>  Thu, 29 Dec 2022 00:44:10 -0300

kristall (0.3+git20210303.763bd81+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/README.Debian: created to explain how to deal with #1018251.
  * debian/control: bumped Standards-Version to 4.6.1.
  * debian/copyright: updated packaging copyright years.
  * debian/gbp.conf: added gbp.conf file.
  * debian/lintian-overrides: add and update text to match current lintian
    messages.
  * debian/patches/:
      - {020,030,040}*: updated patch headers.
      - 050-Make_reproducible_usrmerged.patch: added cherry-pick from
        upstream. Thanks to Vagrant Cascadian for reporting. (Closes: #1007094)
  * debian/watch: update (fix) watch file to work with github

 -- Carlos Henrique Lima Melara <charlesmelara@outlook.com>  Sun, 16 Oct 2022 01:25:29 -0300

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                qt5-qmake,
                qtmultimedia5-dev,
                qttools5-dev-tools
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://kristall.random-projects.net/
 Vcs-Git: https://salsa.debian.org/debian/kristall.git

=== debian/watch ===
version=4
opts="searchmode=plain,\
      filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%,\
      uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|a|b)\d*)$/$1~$2/, \
      dversionmangle=s/@DEB_EXT@//, \
      repacksuffix=+dfsg" \
https://api.github.com/repos/MasterQ32/kristall/releases?per_page=100 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/V?@ANY_VERSION@
